#include <QtGui>

#include "insertdialog.h"
#include "insertthread.h"


insertDialog::insertDialog(QWidget *parent)
    : QDialog(parent)
{

	lbNumber = new QLabel(tr("Datenbankeintrge: 0"));

	lbHoldConnection = new QLabel(tr("HoldConnection"));

	cbHoldConnection = new QCheckBox();
	cbHoldConnection->setChecked(true);

    insertButton = new QPushButton(tr("&Insert"));
    insertButton->setDefault(true);
    insertButton->setEnabled(true);

    connect(insertButton, SIGNAL(clicked()),
            this, SLOT(insertClicked()));

	QHBoxLayout *leftLayout = new QHBoxLayout;
	leftLayout->addWidget(cbHoldConnection);
	leftLayout->addWidget(lbHoldConnection);

    QVBoxLayout *rightLayout = new QVBoxLayout;
	rightLayout->addWidget(lbNumber);
	rightLayout->addLayout(leftLayout);
    rightLayout->addWidget(insertButton);
    rightLayout->addStretch();

    QHBoxLayout *mainLayout = new QHBoxLayout;
    mainLayout->addLayout(rightLayout);
    setLayout(mainLayout);

    setWindowTitle(tr("Insert"));
    setFixedHeight(sizeHint().height());

	thread = new insertThread();
	connect(thread, SIGNAL(numberChanged(int)), this, SLOT(onNumberChanged(int)));

}

void insertDialog::insertClicked()
{
	thread->setHoldConnection(cbHoldConnection->isChecked());
	thread->start();
}

void insertDialog::onNumberChanged(int Number)
{
	QString s;
	s="Datenbankeintrge: ";
	lbNumber->setText(s + NumberToString(Number).c_str());
}
string  insertDialog::NumberToString ( int Number )
{
     ostringstream ss;
     ss << Number;
     return ss.str();
}
