#include "insertthread.h"
#include <QtCore>
#include <QTime>

insertThread::insertThread()
{
    createConnection();
}

void insertThread::run()
{
    QSqlQuery* query;
    int i;
    QString s;
    if (holdConnection) {
        if (!db.open()) {
            QMessageBox::critical(0,QObject::tr("Database Con Error"),db.lastError().text());
        }
        query = new QSqlQuery;
    }
    for(i=0; i < 100000; i++){
        if (0 == (i % 1000))
        {
            writeSystemSize(QString("Systemsize after %1 Datasets").arg(i));
        }
        if (!holdConnection)
        {
            if (!db.open()) {
                QMessageBox::critical(0,QObject::tr("Database Con Error"),db.lastError().text());
            }
            query = new QSqlQuery;
        }
        s="INSERT INTO sql4a (name) VALUES ('";
        s = s + NumberToString(i).c_str() + "')";
        query->exec(s);
        if (!query->isActive())
            QMessageBox::warning(0,QObject::tr("Database Query Error"), query->lastError().text());
        emit numberChanged(i);
        if (!holdConnection)
        {
            query->finish();
            query->clear();
            delete query;
            db.close();
        }
    }
    if (holdConnection)
    {
        query->finish();
        delete query;
        db.close();
    }
}
string  insertThread::NumberToString ( int Number )
{
     ostringstream ss;
     ss << Number;
     return ss.str();
}
bool insertThread::createConnection(){
    db = QSqlDatabase::addDatabase("QODBC");
    db.setDatabaseName("ConsortNoten");							//DSN Name
    db.setUserName("S4AUser");									//Benutzername
    db.setPassword("test");									//Passwort
    if (!db.open()) {
        QMessageBox::critical(0,QObject::tr("Database Con Error"),db.lastError().text());
        return false;
    }
    QSqlQuery query;
    query.exec("DROP TABLE IF EXISTS `sql4a`");
    if (!query.isActive())
        QMessageBox::warning(0,QObject::tr("Database Query Error"), query.lastError().text());

    query.exec("CREATE TABLE `sql4a` ("
        "`iId` int(11) NOT NULL AUTO_INCREMENT,"
        "`name` varchar(45) DEFAULT NULL,"
        "PRIMARY KEY (`iId`)"
        ") ENGINE=InnoDB AUTO_INCREMENT=254792 DEFAULT CHARSET=latin1;");
    if (!query.isActive())
        QMessageBox::warning(0,QObject::tr("Database Query Error"), query.lastError().text());
    query.finish();
    db.close();
    return true;
}
void insertThread::setHoldConnection(bool xHoldConnection)
{
    holdConnection=xHoldConnection;
}

HANDLE                          hProcess = GetCurrentProcess();
PROCESS_MEMORY_COUNTERS         pmc;

void insertThread::writeSystemSize(const QString& Message)
{
    if (NULL != hProcess)
    {
        if (GetProcessMemoryInfo(hProcess, &pmc, sizeof(pmc)))
        {
            qDebug() << QString("SYSTEMSIZE:  %1:  %2 kB (Peak: %3 kB) - %4").arg(QTime::currentTime().toString("HH:mm:ss.zzz"))
                        .arg(pmc.WorkingSetSize / 1024, 5, 10, QChar(' '))
                        .arg(pmc.PeakWorkingSetSize / 1024, 5, 10, QChar(' '))
                        .arg(Message);
        }
    }
}
